CREATE TABLE playlist (
  song_id int(11) NOT NULL default '0',
  playlist_time datetime NOT NULL default '0000-00-00 00:00:00',
  KEY playlist_time (playlist_time)
) TYPE=MyISAM COMMENT='The playlist of songs that have been played';

CREATE TABLE pools (
  pool_id int(11) NOT NULL auto_increment,
  pool_name varchar(255) NOT NULL default '',
  pool_host varchar(255) NOT NULL default '',
  pool_location varchar(255) NOT NULL default '',
  pool_online enum('Y','N') NOT NULL default 'Y',
  pool_description text NOT NULL,
  PRIMARY KEY  (pool_id)
) TYPE=MyISAM COMMENT='Pools of mp3''s, allowing us to switch moods and turn on/off ' AUTO_INCREMENT=10 ;

CREATE TABLE songs (
  song_id int(11) NOT NULL auto_increment,
  pool_id int(11) NOT NULL default '0',
  song_artist varchar(255) NOT NULL default '',
  song_title varchar(255) NOT NULL default '',
  song_album varchar(255) NOT NULL default '',
  song_filename varchar(255) NOT NULL default '',
  song_filesize varchar(255) NOT NULL default '',
  song_active enum('Y','N') NOT NULL default 'Y',
  song_lastchecked timestamp(14) NOT NULL,
  song_albumtrack int(11) NOT NULL default '0',
  song_comment varchar(255) NOT NULL default '',
  song_producer varchar(255) NOT NULL default '',
  song_recordlabel varchar(255) NOT NULL default '',
  song_year int(11) NOT NULL default '0',
  song_genre varchar(255) NOT NULL default '',
  song_genreid int(11) NOT NULL default '0',
  song_voted int(11) NOT NULL default '0',
  song_played int(11) NOT NULL default '0',
  song_tagtype varchar(20) NOT NULL default '',
  PRIMARY KEY  (song_id),
  KEY song_artist (song_artist),
  KEY song_title (song_title),
  KEY song_album (song_album)
) TYPE=MyISAM COMMENT='The songs available on the radio' AUTO_INCREMENT=11978 ;

CREATE TABLE votes (
  song_id int(11) NOT NULL default '0',
  vote_host varchar(255) NOT NULL default '',
  vote_time datetime NOT NULL default '0000-00-00 00:00:00',
  vote_handled enum('Y','N') NOT NULL default 'N',
  KEY song_id (song_id,vote_host),
  KEY vote_handled (vote_handled),
  KEY song_id_2 (song_id)
) TYPE=MyISAM COMMENT='The votes cast by the website';

