# Radio.Unfix signalling script for irssi (http://www.irssi.org)
#
# As irssi is just the best IRC client, here is a nice bonus
# script which can be signalled from Radio.Unfix allowing one
# to do things like getting the title and displaying it.
#
# This script gets a SIGUSR2 from Radio.Unfix
# we then get the current song from the database.
#
# Debugger:
# use Data::Dumper; print Dumper $object;

use Irssi;
use strict;
use vars qw($VERSION %IRSSI);

$VERSION = "1.00";
%IRSSI = (
    authors     => 'Jeroen Massar',
    name        => 'radio',
    description => 'Radio.Unfix signalling script',
    license     => 'Public Domain',
    changed	=> 'Fri Feb 20 16:29 CET 2004'
);

sub radio_handlesignal {
	my $output = `mysql -uradio -pradio radio -r -B --disable-pager -e "SELECT song_artist, song_title FROM playlist INNER JOIN songs ON playlist.song_id = songs.song_id ORDER BY playlist_time DESC LIMIT 0,1" | tail -n 1 | sed 's/\t/ - /'`;

	$output =~ s/\r|\n|\t//;
	Irssi::print("[Radio.Unfix] $output");
}

$SIG{'USR2'} = \&radio_handlesignal

