<?php

global $unfix, $page;
require_once("inc/default.php");
$page["title"] = "Information";

if (isset($_GET["cmd"]))
{
	commands();
}

pagina();

function main()
{
	global $unfix, $wwwdir;

	echo "<div class=\"text\">\n";
	Heading("Radio.Unfix :: Alternative IPv6 Multicast Radio");
	echo "<div style=\"float: right; padding: 10px\">";
	echo "<img src=\"".$wwwdir."gfx/radio.gif\" alt=\"Radio.Unfix\" style=\"border: 1px solid #eeeeee;\" />";
	echo "</div>\n";

	echo "Welcome to Radio.Unfix - Alternative IPv6 Multicast Radio.\n";
	echo "</div>\n";

	echo "<div class=\"text\">\n";
	echo "Using IPv6 Multicast everybody with at least 128kbit/s ";
	echo "upstream can start their own Internet Radio Station with ";
	echo "an unlimited amount of possible endusers who are listening ";
	echo "to your radio!\n";
	echo "For this I have created <a href=\"http://unfix.org/projects/radio/\">Radio.Unfix</a>, ";
	echo "a simple RTP Multicast IPv6 streamer that gets it's next song ";
	echo "from a MySQL database, either from a votequeue or random when ";
	echo "that votequeue is empty.\n";
	echo "Adding a small PHP frontend and a gathering mechanism for ";
	echo "indexing the mp3's into the database et voila one full blown ";
	echo "Internet Radio system with voting capability.\n";
	echo "</div>\n";

	echo "<div class=\"text\">\n";
	echo "As mentioned in the <a href=\"faq/\">FAQ</a> there is no way to download music here.\n";
	echo "</div>\n";

	echo "<div class=\"text\" style=\"clear: both\">\n";
	Heading("Currently Playing");
	currentlyplaying();
	echo "</div>\n";

	echo "<div class=\"text\">\n";
	Heading("Voting Queue");
	listvotes();
	echo "</div>\n";
}

function currentlyplaying()
{
	global $unfix;
	$q =	"SELECT ".
			"playlist_time, ".
			"songs.song_id, ".
			"song_artist, ".
			"song_title ".
		"FROM playlist ".
		"INNER JOIN songs ON playlist.song_id = songs.song_id ".
		"ORDER BY playlist_time DESC ".
		"LIMIT 0,1";

	$rs = $unfix->Query($q);

	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		return;
	}

	if ($rs->numRows() == 0)
	{
		echo "Empty";
		return;
	}

	echo "<table>\n";
	echo "<tr style=\"font-size: medium; background-color: #eeeeee\"><td>Date + Time</td><td>Artist</td><td>Title</td></tr>\n";
	while ($row = $rs->fetchRow())
	{
		list($time, $id, $artist, $title) = $row;

		echo "<tr>";
		echo "<td>".$time."</td>";
		echo "<td><a href=\"songs/?artist=".urlencode($artist)."\">".htmlentities($artist)."</a></td>";
		echo "<td>".htmlentities($title)."</td>";
		echo "</tr>\n";
	}
	echo "</table>\n";
}

function listvotes()
{
	global $unfix;

	$q =	"SELECT ".
			"COUNT(songs.song_id) AS numvotes, ".
			"songs.song_id, ".
			"song_artist, ".
			"song_title ".
		"FROM votes ".
		"INNER JOIN songs ON votes.song_id = songs.song_id ".
		"WHERE vote_handled = 'N' ".
		"GROUP BY songs.song_id ".
		"ORDER BY numvotes DESC, song_artist, song_title";

	$rs = $unfix->Query($q);

	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		return;
	}

	if ($rs->numRows() == 0)
	{
		echo "Empty";
		return;
	}

	echo "<table>\n";
	echo "<tr style=\"font-size: medium; background-color: #eeeeee\"><td>Votes</td><td>Artist</td><td>Title</td></tr>\n";
	while ($row = $rs->fetchRow())
	{
		list($votes, $id, $artist, $title) = $row;

		echo "<tr>";
		echo "<td>".$votes."</td>";
		echo "<td><a href=\"songs/?artist=".urlencode($artist)."\">".htmlentities($artist)."</a></td>";
		echo "<td>".htmlentities($title)."</td>";
		echo "</tr>\n";
	}
	echo "</table>\n";
}

function commands()
{
	global $unfix, $wwwdir;

	if (	$_GET["cmd"] != "vote" ||
		!isset($_GET["id"])) return;

	$id = preg_replace("/[^0-9]/", "", $_GET["id"]);

	$host = preg_replace("/[^0-9\:\.a-f]/", "",$_SERVER["REMOTE_ADDR"]);

	$q = "SELECT COUNT(*) FROM votes WHERE vote_host = '".$host."' AND vote_handled = 'N'";
	$rs = $unfix->Query($q);
	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		exit;
	}

	list($votes) = $rs->fetchRow();

	if ($votes > 50)
	{
		echo "<h1>Vote limit reached</h1>\n";
		echo "Only 50 votes are allowed.\n";
		exit;
	}

	$q = "INSERT INTO votes ".
		"(song_id, vote_host, vote_time, vote_handled) ".
		"VALUES ".
		"('".$id."', '".$host."', now(), 'N')";
	$rs = $unfix->Query($q);
	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		exit;
	}

	$q = "UPDATE songs SET song_voted = song_voted + 1 WHERE song_id = '".$id."'";
	$rs = $unfix->Query($q);
	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		exit;
	}

	header("Location: http://".$_SERVER["SERVER_NAME"].$wwwdir);
	echo "Naaah.. we don't want to allow you to reload :)";

	exit;
}

?>
