<?php

global $unfix, $page;
require_once("../inc/default.php");
$page["title"] = "Songs";

pagina();

function main()
{
	global $unfix;

	if (isset($_GET["artist"]))
	{
		$artist = strtolower(preg_replace("/[^A-Za-z0-9\ \.\&\']/","", urldecode($_GET["artist"])));
		$artist = preg_replace("/[']/", "''", $artist);
	}
	else $artist = "";

	if (isset($_GET["letter"]))
	{
		$letter = substr(strtolower(preg_replace("/[^A-Za-z0-9\ ]/","", $_GET["letter"])),0,1);
	}
	else $letter = "";

	echo "<div class=\"text\">\n";
	Heading("Songs");
	echo "</div>\n";

	echo "<div class=\"text\">\n";
	listletters();
	echo "</div>\n";

	if ($artist != "")
	{
		echo "<div class=\"text\">\n";
		listsongs($artist);
		echo "</div>\n";
	}
	else if ($letter != "")
	{
		echo "<div class=\"text\">\n";
		listletter($letter);
		echo "</div>\n";
	}
	else
	{
		echo "<div class=\"text\">\n";
		statistics();
		echo "</div>\n";
		echo "<div class=\"text\">\n";
		listpools();
		echo "</div>\n";
	}
}

function listsongs($artist)
{
	global $unfix;

	$q =	"SELECT ".
			"song_id, ".
			"song_artist, ".
			"song_title, ".
			"song_played, ".
			"song_voted, ".
			"pool_name, ".
			"pool_online ".
		"FROM songs ".
		"INNER JOIN pools ON songs.pool_id = pools.pool_id ".
		"WHERE song_artist LIKE '".$artist."%' ".
		"ORDER BY song_artist, song_title ";

	$rs = $unfix->Query($q);

	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		return;
	}

	echo "<table>\n";
	echo "<tr style=\"font-size: medium; background-color: #eeeeee\">";
	echo "<td>Vote</td><td>Artist</td><td>Title</td><td>Played<td>Voted</td><td>Pool Name</td>";
	echo "</tr>\n";
	$count = 0;
	while ($row = $rs->fetchRow())
	{
		list($id, $artist, $title, $played, $voted, $pool_name, $pool_online) = $row;
		echo "<tr>";
		if ($pool_online == "Y") echo "<td><a href=\"../?cmd=vote&amp;id=".$id."\">Vote</td>";
		else echo "<td style=\"color: red\">Offline</td>";
		echo "<td>".htmlentities($artist)."</td>";
		echo "<td>".htmlentities($title)."</td>";
		echo "<td>".$played."</td>";
		echo "<td>".$voted."</td>";
		echo "<td>".$pool_name."</td>";
		echo "</tr>\n";
		$count++;
	}
	echo "</table>\n";
	echo "Totaling into ".$count." songs.";
}

function listletter($letter)
{
	global $unfix;

	$q =	"SELECT ".
			"song_artist, ".
			"COUNT(song_id) ".
		"FROM songs ".
		"WHERE song_artist LIKE '".$letter."%' ".
		"GROUP BY song_artist ".
		"ORDER BY song_artist";

	$rs = $unfix->Query($q);

	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		return;
	}

	echo "<table>\n";
	echo "<tr style=\"font-size: medium; background-color: #eeeeee\">";
	echo "<td>Artist</td><td># Songs</td>";
	echo "</tr>\n";
	$count = 0;
	while ($row = $rs->fetchRow())
	{
		list($artist, $numsongs) = $row;
		echo "<tr>";
		echo "<td><a href=\"?artist=".urlencode($artist)."\">".htmlentities($artist)."</a></td>";
		echo "<td style=\"text-align: right\">".$numsongs."</td>";
		echo "</tr>\n";
		$count++;
	}
	echo "</table>\n";
	echo "Totaling into ".$count." artists.";
}

function listletters()
{
	global $unfix;

	$q =	"SELECT ".
			"SUBSTRING(LOWER(song_artist),1,1) AS letter ".
		"FROM songs ".
		"GROUP BY letter ".
		"ORDER BY letter";

	$rs = $unfix->Query($q);

	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		return;
	}

	while ($row = $rs->fetchRow())
	{
		list($letter) = $row;
		echo "<a href=\"?letter=".$letter."\">".strtoupper($letter)."</a> ";
	}
}

function statistics()
{
	global $unfix;

	// Number Of Artists
	$q =	"SELECT COUNT(DISTINCT song_artist) AS cnt ".
		"FROM songs";

	$rs = $unfix->Query($q);
	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		return;
	}
	$row = $rs->fetchRow();
	list($count_artists) = $row;

	// Number Of Songs
	$q =	"SELECT COUNT(song_id), SUM(song_filesize) ".
		"FROM songs";
	$rs = $unfix->Query($q);
	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		return;
	}
	$row = $rs->fetchRow();
	list($count_songs, $size) = $row;

	echo "There are ".$count_artists." artists and ";
	echo $count_songs." songs, ";
	echo "totaling ".humansize($size).", ";

	$factor = 10;
	echo "which is an estimate of ".ceil(($size*$factor)/(640*1024*1024))." hours of music*.\n";
	echo "<div style=\"font-size: xx-small;\">* = based on the filesize and a mp3 compression factor of 1:".$factor.".</div>\n";
}

function listpools()
{
	global $unfix;

	$q =	"SELECT ".
			"pool_name, ".
			"pool_host, ".
			"pool_online, ".
			"pool_description, ".
			"COUNT(song_id), ".
			"SUM(song_filesize) ".
			"FROM pools ".
		"INNER JOIN songs ON pools.pool_id = songs.pool_id ".
		"GROUP BY songs.pool_id ".
		"ORDER BY pool_name";
	$rs = $unfix->Query($q);
	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		return;
	}

	if ($rs->numRows() == 0) return;

	Heading("Audio Pools");
	echo "<div class=\"text\">\n";
	echo "As storing everything on one host is not feasible and some machines make a bit too much ";
	echo "noise, those hosts won't always be online. Next to that sometimes one would like to pick ";
	echo "another type of category of music depending on ones mood.\n";
	echo "To solve these problems Radio.Unfix has a couple of pools which are also host dependend.\n";
	echo "Using the uptime feature of <a href=\"http://dapd.sf.net\">DAPd</a> we can check ";
	echo "if a host is still online, if not it marks it as offline and thus makes the pool ";
	echo "unavailable avoiding the player and webinterface to pick songs from those pools.\n";
	echo "We can also mark a pool as unavailable when we are not in the mood for that pool's kind of music.\n";
	echo "</div>\n";

	echo "<table>\n";
	echo "<tr style=\"background-color: #eeeeee; font-size: medium\">";
	echo "<td>Name</td>";
	echo "<td>Host</td>";
	echo "<td style=\"white-space: nowrap\"># Songs</td>";
	echo "<td>Size</td>";
	echo "<td>Status</td>";
	echo "<td>Description</td>";
	echo "</tr>\n";

	$totsongs = 0;
	$totsize = 0;

	while ($row = $rs->fetchRow())
	{
		list($pool_name, $pool_host, $pool_online, $pool_description, $songs, $size) = $row;

		$totsongs+=$songs;
		$totsize+=$size;

		echo "<tr>";
		echo "<td style=\"white-space: nowrap\">".htmlentities($pool_name)."</td>";
		echo "<td>".htmlentities($pool_host)."</td>";
		echo "<td style=\"text-align: right\">".$songs."</td>";
		echo "<td style=\"white-space: nowrap; text-align: right\">".humansize($size)."</td>";
		if ($pool_online == "Y") echo "<td style=\"color: green\">Online</td>";
		else echo "<td style=\"color: red\">Offline</td>";
		echo "<td>".htmlentities($pool_description)."</td>";
		echo "</tr>\n";
	}
	echo "<tr style=\"background-color: #eeeeee\">";
	echo "<td>Total</td>";
	echo "<td></td>";
	echo "<td style=\"text-align: right\">".$totsongs."</td>";
	echo "<td style=\"white-space: nowrap; text-align: right\">".humansize($totsize)."</td>";
	echo "<td></td>";
	echo "<td></td>";
	echo "</table>\n";
}

function humansize($size)
{
	if ($size < 1024)
		$str = sprintf("%01.2f Bytes", $size);
	else if ($size < (1024*1024))
		$str = sprintf("%01.2f Kibi", $size/1024);
	else if ($size < (1024*1024*1024))
		$str = sprintf("%01.2f Mibi", $size/(1024*1024));
	else if ($size < (1024*1024*1024*1024))
		$str = sprintf("%01.2f Gibi", $size/(1024*1024*1024));
	return $str;
}

?>
