<?php

global $unfix, $page, $max;
$max = 25;
require_once("../inc/default.php");
$page["title"] = "Top ".$max;

pagina();

function main()
{
	global $unfix, $max;

	echo "<div class=\"text\">\n";
	Heading("Top ".$max." Played Songs");
	topsong("song_played", $max);
	echo "</div>\n";

	echo "<div class=\"text\">\n";
	Heading("Top ".$max." Voted Songs");
	topsong("song_voted", $max);
	echo "</div>\n";

	echo "<div class=\"text\">\n";
	Heading("Top ".$max." Artists (plays)");
	topartist("plays", $max);
	echo "</div>\n";

	echo "<div class=\"text\">\n";
	Heading("Top ".$max." Artists (votes)");
	topartist("votes", $max);
	echo "</div>\n";
}

function topsong($order, $top)
{
	global $unfix;

	$q =	"SELECT ".
			"song_id, ".
			"song_artist, ".
			"song_title, ".
			"song_played, ".
			"song_voted ".
		"FROM songs ".
		"WHERE song_played > 0 OR song_voted > 0 ".
		"ORDER BY ".$order." DESC, song_artist, song_title ".
		"LIMIT 0, ".$top;

	$rs = $unfix->Query($q);

	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		return;
	}

	echo "<table>\n";
	echo "<tr style=\"font-size: medium; background-color: #eeeeee\">";
	echo "<td>Vote</td><td>Artist</td><td>Title</td><td># Plays</td><td># Votes</td>";
	echo "</tr>\n";
	while ($row = $rs->fetchRow())
	{
		list($id, $artist, $title, $played, $voted) = $row;
		echo "<tr>";
		echo "<td><a href=\"../?cmd=vote&amp;id=".$id."\">Vote</td>";
		echo "<td><a href=\"../songs/?artist=".urlencode($artist)."\">".htmlentities($artist)."</a></td>";
		echo "<td>".htmlentities($title)."</td>";
		echo "<td style=\"text-align: right\">".$played."</td>";
		echo "<td style=\"text-align: right\">".$voted."</td>";
		echo "</tr>\n";
	}
	echo "</table>\n";
}

function topartist($order, $top)
{
	global $unfix;

	$q =	"SELECT ".
			"song_artist, ".
			"SUM(song_played) AS plays, ".
			"SUM(song_voted) AS votes ".
		"FROM songs ".
		"GROUP BY song_artist ".
		"ORDER BY ".$order." DESC, song_artist, song_title ".
		"LIMIT 0, ".$top;

	$rs = $unfix->Query($q);

	if (!$unfix->QueryOk($rs))
	{
		echo $unfix->error;
		return;
	}
	echo "<table>\n";
	echo "<tr style=\"font-size: medium; background-color: #eeeeee\">";
	echo "<td>Artist</td><td># Plays</td><td># Votes</td>";
	echo "</tr>\n";
	while ($row = $rs->fetchRow())
	{
		list($artist, $played, $voted) = $row;
		// Don't list non-played/voted artists
		if ($played == 0 && $voted == 0) continue;
		echo "<tr>";
		echo "<td><a href=\"../songs/?artist=".urlencode($artist)."\">".htmlentities($artist)."</a></td>";
		echo "<td style=\"text-align: right\">".$played."</td>";
		echo "<td style=\"text-align: right\">".$voted."</td>";
		echo "</tr>\n";
	}
	echo "</table>\n";
}

?>
