/* Radio.Unfix - radio.h - Common Header */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <sys/time.h>
#include <unistd.h>
#include <fcntl.h>
#include <syslog.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <time.h>
#include <sys/time.h>
#include <sys/un.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <mysql/mysql.h>

#define BSIZE 2048			/* Fixed-sized bufs for reading strings */
#define INTERFACES 2			/* To how many interfaces to send traffic */
#define INTEGER_STRING_SIZE 10		/* How long do we want integers to be? */

typedef struct RTPHeader {
	int flags;
	int timestamp;
	int syncsource_id;
	int audioheader;
} RTPHeader;

/* Debug macro */
#ifdef DEBUG
#define D(x) x
#else
#define D(x) {}
#endif

/* common.c */
void dolog(int priority, const char *format, ...);
void query(int arglen, void *template, ...);
int ReadConfigFile(void);

struct line
{
	struct addrinfo		*sSockAddr,
				*sTitleAddr;
	int			Socket;
	int			TitleSocket;
	unsigned int		Interface;
};

struct Radio
{
	char			*c_ConfigFile;
	char			*c_DB_Server;
	char			*c_DB_Name;
	char			*c_DB_User;
	char			*c_DB_Password;
	char			*c_URL;
	char			*c_StreamTitle;
	char			*c_PlayingTitle;
	char			*c_Multicast_Source;
	char			*c_Multicast_Address;
	char			*c_Multicast_Audio_Port;
	char			*c_Multicast_Title_Port;
	char			*c_PIDFile;
	char			*c_SignalsFile;
	int			c_Daemonize;
	struct line		*lines;
	unsigned int		interfaces;
	unsigned int		c_MTU;
	unsigned int		c_HopLimit;

	/* Global Variables */
	MYSQL	*db;
};

/* Configuration information - radio.c / gatherer.c */
extern struct Radio radio;

